Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.csproj	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.csproj	(revision 5560)
@@ -107,24 +107,15 @@
   <ItemGroup>
     <Compile Include="BestPointInitializer.cs" />
-    <Compile Include="IDiscreteDoubleMatrixModifier.cs" />
-    <Compile Include="IGlobalParticleUpdater.cs" />
-    <Compile Include="ILocalParticleUpdater.cs" />
     <Compile Include="MultiPSOTopologyUpdater.cs" />
+    <Compile Include="ParticleSwarmOptimizationMainLoop.cs" />
     <Compile Include="VelocityBoundsModifier.cs" />
     <Compile Include="RandomTopologyInitializer.cs" />
     <Compile Include="VonNeumannTopologyInitializer.cs" />
     <Compile Include="RingTopologyInitializer.cs" />
-    <Compile Include="ITopologyUpdater.cs" />
     <Compile Include="NeighborUpdater.cs" />
     <Compile Include="TopologyInitializer.cs" />
-    <Compile Include="ITopologyInitializer.cs" />
-    <Compile Include="NeighborhoodParticleUpdater.cs" />
-    <Compile Include="IParticleUpdater.cs" />
-    <Compile Include="TotallyConnectedParticleUpdater.cs" />
     <Compile Include="HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs" />
     <Compile Include="ParticleSwarmOptimization.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ParticleUpdater.cs" />
-    <Compile Include="SwarmUpdater.cs" />
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs.frame	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs.frame	(revision 5560)
@@ -34,5 +34,4 @@
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.RealVectorEncoding", "3.3")]
-  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/MultiPSOTopologyUpdater.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/MultiPSOTopologyUpdater.cs	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/MultiPSOTopologyUpdater.cs	(revision 5560)
@@ -25,13 +25,13 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
-  [Item("Multi PSO Topology Initializer/Updater", "Splits swarm into swarmsize / (nrOfConnections + 1) non-overlapping sub-swarms. Swarms are re-grouped every regroupingPeriod iteration. The operator is implemented as described in Liang, J.J. and Suganthan, P.N 2005. Dynamic multi-swarm particle swarm optimizer. IEEE Swarm Intelligence Symposium, pp. 124-129.")]
+  [Item("Multi PSO Topology Updater", "Splits swarm into swarmsize / (nrOfConnections + 1) non-overlapping sub-swarms. Swarms are re-grouped every regroupingPeriod iteration. The operator is implemented as described in Liang, J.J. and Suganthan, P.N 2005. Dynamic multi-swarm particle swarm optimizer. IEEE Swarm Intelligence Symposium, pp. 124-129.")]
   [StorableClass]
-  public sealed class MultiPSOTopologyUpdater : SingleSuccessorOperator, ITopologyUpdater, ITopologyInitializer {
+  public sealed class MultiPSOTopologyUpdater : SingleSuccessorOperator, ITopologyUpdater {
     public override bool CanChangeName {
       get { return false; }
@@ -48,6 +48,6 @@
       get { return (ILookupParameter<IntValue>)Parameters["SwarmSize"]; }
     }
-    public IScopeTreeLookupParameter<IntegerVector> NeighborsParameter {
-      get { return (IScopeTreeLookupParameter<IntegerVector>)Parameters["Neighbors"]; }
+    public IScopeTreeLookupParameter<IntArray> NeighborsParameter {
+      get { return (IScopeTreeLookupParameter<IntArray>)Parameters["Neighbors"]; }
     }
     public ILookupParameter<IntValue> CurrentIterationParameter {
@@ -69,5 +69,5 @@
       get { return SwarmSizeParameter.ActualValue.Value; }
     }
-    private ItemArray<IntegerVector> Neighbors {
+    private ItemArray<IntArray> Neighbors {
       get { return NeighborsParameter.ActualValue; }
       set { NeighborsParameter.ActualValue = value; }
@@ -84,4 +84,5 @@
     private MultiPSOTopologyUpdater(bool deserializing) : base(deserializing) { }
     private MultiPSOTopologyUpdater(MultiPSOTopologyUpdater original, Cloner cloner) : base(original, cloner) { }
+    
     public MultiPSOTopologyUpdater()
       : base() {
@@ -89,5 +90,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("NrOfConnections", "Nr of connected neighbors.", new IntValue(3)));
       Parameters.Add(new LookupParameter<IntValue>("SwarmSize", "Number of particles in the swarm."));
-      Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>("Neighbors", "The list of neighbors for each particle."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntArray>("Neighbors", "The list of neighbors for each particle."));
       Parameters.Add(new LookupParameter<IntValue>("CurrentIteration", "The current iteration of the algorithm."));
       Parameters.Add(new ValueLookupParameter<IntValue>("RegroupingPeriod", "Update interval (=iterations) for regrouping of neighborhoods.", new IntValue(5)));
@@ -100,6 +101,6 @@
     // Splits the swarm into non-overlapping sub swarms
     public override IOperation Apply() {
-      if (CurrentIteration % RegroupingPeriod == 0) {
-        ItemArray<IntegerVector> neighbors = new ItemArray<IntegerVector>(SwarmSize);
+      if (CurrentIteration > 0 && CurrentIteration % RegroupingPeriod == 0) {
+        ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
         Dictionary<int, List<int>> neighborsPerParticle = new Dictionary<int, List<int>>();
         for (int i = 0; i < SwarmSize; i++) {
@@ -135,5 +136,5 @@
 
         for (int particle = 0; particle < neighborsPerParticle.Count; particle++) {
-          neighbors[particle] = new IntegerVector(neighborsPerParticle[particle].ToArray());
+          neighbors[particle] = new IntArray(neighborsPerParticle[particle].ToArray());
         }
         Neighbors = neighbors;
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/NeighborUpdater.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/NeighborUpdater.cs	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/NeighborUpdater.cs	(revision 5560)
@@ -24,5 +24,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Operators;
@@ -42,6 +41,6 @@
       get { return (IScopeTreeLookupParameter<RealVector>)Parameters["Point"]; }
     }
-    public IScopeTreeLookupParameter<IntegerVector> NeighborsParameter {
-      get { return (IScopeTreeLookupParameter<IntegerVector>)Parameters["Neighbors"]; }
+    public IScopeTreeLookupParameter<IntArray> NeighborsParameter {
+      get { return (IScopeTreeLookupParameter<IntArray>)Parameters["Neighbors"]; }
     }
     public IScopeTreeLookupParameter<RealVector> BestNeighborPointParameter {
@@ -60,5 +59,5 @@
       get { return PointsParameter.ActualValue; }
     }
-    private ItemArray<IntegerVector> Neighbors {
+    private ItemArray<IntArray> Neighbors {
       get { return NeighborsParameter.ActualValue; }
     }
@@ -80,6 +79,6 @@
     private NeighborUpdater(NeighborUpdater original, Cloner cloner) : base(original, cloner) { }
     public NeighborUpdater() {
-      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("Point", "The position of the particle."));
-      Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>("Neighbors", "The list of neighbors for each particle."));
+      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("RealVector", "The position of the particle."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntArray>("Neighbors", "The list of neighbors for each particle."));
       Parameters.Add(new ScopeTreeLookupParameter<RealVector>("BestNeighborPoint", "The position of the best neighboring particle."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The list of qualities of all particles."));
